#include <acknex.h>
#include <default.c>



BMAP* filmski = "filmski.pcx";
BMAP* cro_games = "cro_games.pcx";
BMAP* cro_games_ptp = "cro_games_is_ptp.pcx";
BMAP* txt_baza = "baza_txt.pcx";
BMAP* txt_solarni = "solarni_txt.pcx";
BMAP* cg_ts = "cg_ts.pcx";
BMAP* strelica_bmp = "strelica.bmp";
BMAP* strldo_1 = "strldo_1.bmp";
BMAP* strldo_2 = "strldo_2.bmp";
BMAP* strlg_1 = "strlg_1.bmp";
BMAP* strlg_2 = "strlg_2.bmp";
BMAP* stalna_ro1 = "stalna_ro1.bmp";
BMAP* broj_krugova = "broj_krugova.bmp";
BMAP* str_test1 = "str_test1.bmp";
BMAP* str_test2 = "str_test2.bmp";
BMAP* CG = "CG.pcx";
BMAP* koji_je_krug = "koji_je_krug.bmp";
BMAP* greska = "greska.bmp";
BMAP* izadi = "izadi.bmp";
BMAP* izadi2 = "izadi2.bmp";
BMAP* tfptg = "tfptg.pcx";
BMAP* qg = "qg.pcx";
BMAP* yes1 = "yes1.bmp";
BMAP* yes2 = "yes2.bmp";
BMAP* no1 = "no1.bmp";
BMAP* no2 = "no2.bmp";

FONT* digit_font = "brojni_font.bmp";

SOUND* mot = "vlak.wav";
SOUND* koc = "kocenje.wav";
SOUND* klik = "klik.wav";


PANEL* ime_igre = 
{ 
bmap = CG; 
flags = visible,transparent;
pos_x = -1; 
pos_y = -1;
layer = 2;
}

PANEL* tfptg_pan = 
{ 
bmap = tfptg; 
flags = transparent;
pos_x = -1; 
pos_y = -1;
layer = 10;
}

PANEL* filmski_pan = 
{ 
bmap = filmski; 
flags = overlay,transparent,visible; 
pos_x = -1; 
pos_y = -1;
}

PANEL* cro_games_pan = 
{ 
bmap = cro_games; 
flags = transparent,visible; 
layer = 5;
pos_x = -1; 
pos_y = -1;
}

PANEL* txt_baza_pan = 
{ 
bmap = txt_baza; 
flags = transparent,visible; 
layer = 1;
pos_x = 10; 
pos_y = 10;
}

PANEL* txt_solarni_pan = 
{ 
bmap = txt_solarni; 
flags = transparent,visible; 
layer = 1;
pos_x = 10; 
pos_y = 10;
}

PANEL* cro_games_ptp_pan = 
{ 
bmap = cro_games_ptp; 
flags = transparent,visible; 
layer = 4;
pos_x = -1; 
pos_y = -1;
}

PANEL* cg_ts_pan = 
{ 
bmap = cg_ts; 
flags = transparent,visible; 
layer = 3;
pos_x = -1; 
pos_y = -1;
}

PANEL* broj_krugova_pan = 
{ 
bmap = broj_krugova; 
flags = transparent,visible,overlay; 
layer = 1;
pos_x = 10; 
pos_y = 10;
}

PANEL* koji_je_krug_pan = 
{ 
bmap = koji_je_krug; 
flags = transparent,visible,overlay; 
digits(248,10,2,digit_font,1,broj_test_krugova);
digits(176,10,2,digit_font,1,odvz_krugova);
layer = 1;
pos_x = 135; 
pos_y = 10;
}


PANEL* greska_pan = 
{ 
bmap = greska; 
flags = transparent,visible,overlay; 
layer = 1;
pos_x = 150; 
pos_y = 250;
}

PANEL* qg_pan =
{
bmap = qg; 
flags = transparent,visible,overlay; 
button = 150,50,yes2,yes1,yes2,kraj_igre,null,klik_fn3;
button = 286,50,no2,no1,no2,nastavi_igrat,null,klik_fn3;
layer = 7;
pos_x = 150; 
pos_y = 250;
}

PANEL* izadi_pan = 
{ 
flags = transparent,visible,overlay; 
layer = 8;
button = 758,10,izadi2,izadi,izadi2,dali_zavrsit,null,klik_fn2;
}

PANEL* tipke =
{
  button = 720,520,strldo_2,strldo_1,strldo_2,broj_test_krugova_min,null,klik_fn;
  button = 720,450,strlg_2,strlg_1,strlg_2,broj_test_krugova_plu,null,klik_fn;
  button = 720,485,stalna_ro1,stalna_ro1,stalna_ro1,null,null,null;
  button = 10,550,str_test2,str_test1,str_test2,start_testing,null,klik_fn;
  flags = visible,overlay,transparent;
  layer = 7;
}




PANEL* tekst_pan =
{
digits(720,499,2,digit_font,1,broj_test_krugova);
layer = 7;
flags = visible,transparent;
}


var broj_tocke = 1;
var broj_tocke_2 = 1;
var brzina = 8;
var kolko_ima_tocki;
var kolko_ima_tocki_2;
var a1;
var a2;
var vag;
var lokma;
var lok;
var test;
var rot_kam_rot;
var broj_kamera = 1;
var kolko_ima_kamera;
var glediste = 0;
var broj_test_krugova;
var odvz_krugova;
var dali_vozi;
var proba;
var zvuk_motora;
var kocenje;


ENTITY* vlak;
ENTITY* vagon1;
ENTITY* mak_lok;
ENTITY* mak_vag1;
ENTITY* baza_tdc_en;

VECTOR kretanje_vlaka, kretanje_vagona , rotacija , rotacija2;


action lokomotiva()
{ 
   var jac_zvuka;
	vlak = my;
	my.skill2 = 1;
	while(1)
	{
	jac_zvuka = (100/(vec_dist(my.x,camera.x)))*70;
	snd_tune (kocenje,jac_zvuka,100, 0);
	snd_tune (zvuk_motora,jac_zvuka,100, 0);
	lokma = my.pan;
	kretanje_vlaka.x = brzina;
	ent_move(kretanje_vlaka,nullvector);
   if(broj_tocke == 2)
   {
		while(broj_tocke_2 != 2)
	{
		wait(1);
	}
   }
	wait(1);
	}
}

action pocetna_pozicija_lo()
{
	while(1)
	{
		if(broj_tocke == 1)
		{
		odvz_krugova += 1;
		vlak.x = my.x;
		vlak.y = my.y;
		vlak.z = my.z;
		vlak.pan = my.pan;
		if(vlak.pan < 0)
		{
			mak_lok.pan = (vlak.pan + 360);
		}
		else
		{
			mak_lok.pan = vlak.pan;
		}
		broj_tocke = 2;	
		}
		wait(1);
	}
}

action maketa_lokomotive()
{
			if(vlak.pan < 0)
		{
			my.pan = (vlak.pan + 360);
		}
		else
		{
			my.pan = vlak.pan;
		}
	mak_lok = my;
	while(1)
	{
		if(broj_tocke == 1)
		{
		my.x = vlak.x;	
		my.y = vlak.y;
		my.z = vlak.z;
		if(vlak.pan < 0)
		{
			my.pan = (vlak.pan + 360);
		}
		else
		{
			my.pan = vlak.pan;
		}
		}
		
		if(vlak.pan < 0)
		{
			lok = (vlak.pan + 360);
		}
		else
		{
			lok = vlak.pan;
		}
		
		my.x = vlak.x;
		my.y = vlak.y;
		my.z = vlak.z;
		
		if(my.pan > lok +2)
	   {
		my.pan -= 2;
		}		
		else
		{
		if(my.pan < lok - 2)
		{
		  if(broj_tocke == 48)
			{
				if(my.pan < 300)
				{
					my.pan = 367;
				}	
				else
				{
					my.pan += 2;
				}
			}
			else
			{
				my.pan += 2;
			}
		}
		else
		{
			my.pan = lok;
		}	
		}
		



	wait(1);
	}
}

action sjaj_nep_obj()
{
	while(1)
	{
		my.skin -= (1.1-(1.1/brzina));
		if(my.skin <= 1)
		{ 
		my.skin = 32;
		}
		my.alpha = 20;
		wait(1);
   }
}

action sjaj_lokomotive()
{
	my.skin = 32;
	while(1)
	{
		my.x = mak_lok.x;
		my.y = mak_lok.y;
		my.z = mak_lok.z;	
		my.pan = mak_lok.pan;
		my.skin -= (0.8-(0.7/brzina))*1.5;
		if(my.skin <= 1)
		{ 
		my.skin = 32;
		}
		my.alpha = 30;
		wait(1);
   }
}

action vagon()
{
	my.skill2 = 1;
	vagon1 = my;
	while(1)
	{
		test = vec_dist(my.x,vlak.x);
		kretanje_vagona.x = brzina;
		ent_move(kretanje_vagona,nullvector);
		wait(1);
	}
}

action pocetna_pozicija_va()
{
	while(1)
	{
		if(broj_tocke_2 == 1)
		{
		vagon1.x = my.x;
		vagon1.y = my.y;
		vagon1.z = my.z;
		vagon1.pan = my.pan;
		broj_tocke_2 = 2;	
	   if(vagon1.pan < 0)
		{
			mak_vag1.pan = (vagon1.pan + 360);
		}
		else
		{
			mak_vag1.pan = vagon1.pan;
		}
		}
		wait(1);
	}
}


action maketa_vagona()
{
	    if(vagon1.pan < 0)
		{
			my.pan = (vagon1.pan + 360);
		}
		else
		{
			my.pan = vagon1.pan;
		}
		mak_vag1 = my;
	while(1)
	{
		my.x = vagon1.x;
		my.y = vagon1.y;
		my.z = vagon1.z;
      
     	if(broj_tocke_2 == 1)
		{
		my.x = 1120;	
		my.y = 3720;
		my.z = 0;
		}
      
      if(vagon1.pan < 0)
		{
			vag = (vagon1.pan + 360);
		}
		else
		{
			vag = vagon1.pan;
		}
		
		if(my.pan > vag +2)
		{
			if(broj_tocke_2 == 48)
			{
			my.pan = 367;	
			}
			else
			{
				my.pan -= 2;
			}
		}		
		else
		{
		if(my.pan < vag - 0.5)
		{
			if(broj_tocke_2 == 48)
			{
			my.pan = 367;	
			}
			else
			{
				my.pan += 2;
			}
		}
		else
		{
			my.pan = vag;
		}	
		}
      camera.clip_near = 0;
		wait(1);
	}
}

action sjaj_vagona()
{
	my.skin = 32;
	while(1)
	{
		my.x = mak_vag1.x;
		my.y = mak_vag1.y;
		my.z = mak_vag1.z;	
		my.pan = mak_vag1.pan;
		my.skin -= (0.8-(0.7/brzina))*1.5;
		if(my.skin <= 1)
		{ 
		my.skin = 32;
		}
		my.alpha = 30;
		wait(1);
   }
}







action tocka()
{
	kolko_ima_tocki += 1;
	my.skill1 = kolko_ima_tocki;
	while(1)
	{
		
		if(my.skill1 == broj_tocke)
		{
			  vec_set(rotacija, my.x); 
	        vec_sub(rotacija, vlak.x);
	        vec_to_angle(vlak.pan, rotacija);
			if(vec_dist(my.x,vlak.x)<20)
			{
			broj_tocke += 1;
			}
			my.skill2 = (broj_tocke - 1);
			if(my.skill2 == kolko_ima_tocki)
			{
				broj_tocke = 1;
			}
		}
		wait(1);
	}
}

action tocka2()
{
	kolko_ima_tocki_2 += 1;
	my.skill1 = kolko_ima_tocki_2;
	while(1)
	{
		if(my.skill1 == broj_tocke_2)
		{
			  vec_set(rotacija2, my.x); 
	        vec_sub(rotacija2, vagon1.x);
	        vec_to_angle(vagon1.pan, rotacija2);
			if(vec_dist(my.x,vagon1.x)<20)
			{
			broj_tocke_2 += 1;
			}
			my.skill2 = (broj_tocke_2 - 1);
			if(my.skill2 == kolko_ima_tocki_2)
			{
				broj_tocke_2 = 1;
			}
		}
		wait(1);
	}
}

function kretanje_misa()
{
	while(1)
	{
      mouse_pos.x = mouse_cursor.x;
      mouse_pos.y = mouse_cursor.y;
	   mouse_map = strelica_bmp;
	   mouse_mode = 2;
		wait(1);
	}
}

function tipke_fn()
{
	while(1)
	{
		if(dali_vozi == 2)
		{
			if(tekst_pan.alpha < 80)
			{
			tekst_pan.alpha += 5;
			}
			
			if(tipke.alpha < 80)
			{
			tipke.alpha += 5;
			}
			
			if(broj_krugova_pan.alpha < 50)
			{
				broj_krugova_pan.alpha += 5;
			}
			
		}
		else
		{
			if(tekst_pan.alpha > 0)
			{
			tekst_pan.alpha -= 5;
			}
			else
			{
			tekst_pan.alpha = 0;	
			}
			
			if(tipke.alpha > 0)
			{
			tipke.alpha -= 5;
			}	
			else
			{
			tipke.alpha = 0;	
			}
			
			if(broj_krugova_pan.alpha > 0)
			{
				broj_krugova_pan.alpha -= 5;
			}
			else
			{
			   broj_krugova_pan.alpha = 0;	
			}

		}
		
		if(dali_vozi == 0)
		{
			if(koji_je_krug_pan.alpha < 50)
			{
				koji_je_krug_pan.alpha += 1;
			}
				else
			{
			   koji_je_krug_pan.alpha = 50;	
			}
		}
		else
		{
			if(koji_je_krug_pan.alpha > 0)
			{
				koji_je_krug_pan.alpha -= 1;
			}
				else
			{
			   koji_je_krug_pan.alpha = 0;	
			}	
		}
		wait(1);
	}
}

function main()
{ 
   tfptg_pan.alpha = 0;
   enable_key = OFF;
	dali_vozi = 1;
	tipke_fn();
	qg_pan.alpha = 0;
	broj_krugova_pan.alpha = 0;
	izadi_pan.alpha = 0;
	tipke.alpha = 0; 
	txt_baza_pan.alpha = 100; 
	filmski_pan.alpha = 100;
	cro_games_pan.alpha = 100;
	greska_pan.alpha = 0;
	cro_games_ptp_pan.alpha = 100;
	cg_ts_pan.alpha = 100;
	txt_solarni_pan.alpha = 0;
   video_mode = 7;
   video_depth = 32;
   video_screen = 1;
	shadow_stencil = 1;	
   shadow_threshold = 0;	
	sound_vol = 100;
	ime_igre.alpha = 100;
	ent_createlayer("nebo+6.pcx", SKY | CUBE | VISIBLE, 0);
	level_load("vlak.wmb");
	media_loop("glazba.wma",0,100);
	fps_min = 30;
	fps_max = 35;
	wait(-1);
	brzina = 0;
	wait(32);
	zvuk_motora = snd_loop(mot, 100, 0);
   while(cro_games_pan.alpha > 0)
	{
		cro_games_pan.alpha -= 1;
		wait(1);
	}
	wait(60);
	while(cro_games_ptp_pan.alpha > 0)
	{
		cro_games_ptp_pan.alpha -= 1;
		wait(1);
	}
	wait(60);
	while(cg_ts_pan.alpha > 0)
	{
		cg_ts_pan.alpha -= 1;
		wait(1);
	}
	wait(60);
	while(ime_igre.alpha > 0)
	{
		ime_igre.alpha -= 1;
		wait(1);
	}
   filmski_pan.alpha = 100;
   glediste = 1;
   while(glediste == 1)
   {
   	wait(1);
   }
   while(txt_baza_pan.alpha > 0)
   {
   	txt_solarni_pan.alpha += 5;
   	txt_baza_pan.alpha -= 5;
   	wait(1);
   }
   while(brzina < 20)
   {
   	brzina += 2;
   	wait(1);
   }
   while(glediste == 2)
   {
   	if(broj_tocke > 8)
   	{
   	if(brzina > 0)
   	{
   	if(kocenje == 0)
   	{
   	kocenje = snd_loop(koc, 100, 0);	
      }
   	brzina -= 0.18;
      }
      else
      {
      snd_stop(kocenje);
      kocenje = 0;
      brzina = 0;
      glediste = 2.1;	
      }
      }
   	wait(1);
   }
   while(filmski_pan.alpha > 0)
   {
   	txt_solarni_pan.alpha -= 5;
   	filmski_pan.alpha -= 1;
   	wait(1);
   }
   dali_vozi = 2;
   izadi_pan.alpha = 80;
   kretanje_misa();
   while(1)
   {
   	if(glediste >= 2)
   	{
   		if(odvz_krugova != broj_test_krugova)
   		{
   			wait(1);
         }
         else
         {
          if(broj_tocke > 8)
   	   {
   	   if(brzina > 0)
   	   {
   	    if(kocenje == 0)
   	    {
   	    kocenje = snd_loop(koc, 100, 0);	
          }
   	   brzina -= 0.315;
   	   glediste = 2;
         }
         else
         {
         snd_stop(kocenje);
         kocenje = 0;
         dali_vozi = 2;
         brzina = 0;	
         }
         }
         }
      }
   	wait(1);
   }
}

action biljka()
{
	while(1)
	{
		if(vec_dist(my.x,camera.x)> 4000)
		{
			if(my.alpha > 0)
			{
				my.alpha -= 5;
			}
			else
			{
				my.alpha = 0;

			}
		}
		else
		{

			if(my.alpha < 100)
			{
				my.alpha += 5;
			}
			else
			{
				my.alpha = 100;
			}	
		}
		wait(1);
	}
}

action kamera_prateca()
{
	kolko_ima_kamera += 1;
	my.skill1 = kolko_ima_kamera;
	while(1)
	{
		if(broj_kamera == my.skill1)
		{
		vec_set(rot_kam_rot, vlak.x); 
	   vec_sub(rot_kam_rot, my.x);
	   vec_to_angle(my.pan, rot_kam_rot);
	   if(glediste == 3)
	   {
	   camera.x = my.x;
      camera.y = my.y;
      camera.pan = my.pan;
      camera.tilt = my.tilt;
      camera.z = my.z;		
    	}
      
      if(vec_dist(my.x,vlak.x )> 1500)
      {
      broj_kamera += 1;	
      }
      
      if(kolko_ima_kamera+1 == broj_kamera)
      {
      	broj_kamera = 1;
      }
     
		}

		wait(1);
	}
}

action kamera1()
{
	var rot_kam_a1;
   vec_set(rot_kam_a1, baza_tdc_en.x); 
	vec_sub(rot_kam_a1, my.x);
	vec_to_angle(my.pan, rot_kam_a1);
	camera.x = my.x;
   camera.y = my.y;
   camera.pan = my.pan;
   camera.tilt = my.tilt;
   camera.z = my.z;
	while(1)
	{
		vec_set(rot_kam_a1, baza_tdc_en.x); 
	   vec_sub(rot_kam_a1, my.x);
	   vec_to_angle(my.pan, rot_kam_a1);
		if(glediste == 1)
	   {
	   camera.x = my.x;
      camera.y = my.y;
      camera.pan = my.pan;
      camera.tilt = my.tilt;
      camera.z = my.z;	
      if(my.z > 35)
      {
      my.z -= 5;	
      }
      else
      {
      glediste = 2;	
      }	
    	}
		wait(1);
	}
}


action kamera2()
{
	var rot_kam_a2;
	while(1)
	{
		vec_set(rot_kam_a2, vlak.x); 
	   vec_sub(rot_kam_a2, my.x);
	   vec_to_angle(my.pan, rot_kam_a2);
	   if(glediste < 3)
	   {
	  	if(glediste > 1.9)
	   {
	   camera.x = my.x;
      camera.y = my.y;
      camera.pan = my.pan;
      camera.tilt = my.tilt;
      camera.z = my.z;		
    	}
	   }
		wait(1);
	}
}


action antena()
{
	while(1)
	{
		my.pan += 1;
		wait(1);
	}
}

action baza_tdc()
{
	baza_tdc_en = my;
}

function broj_test_krugova_min()
{
if(tipke.alpha > 5)
{
broj_test_krugova -= 1;	
if(broj_test_krugova < 0)
{
	broj_test_krugova = 99;
}
}
}

function broj_test_krugova_plu()
{
if(tipke.alpha > 5)
{
broj_test_krugova += 1;	
if(broj_test_krugova > 99)
{
	broj_test_krugova = 0;
}
}
}

function start_testing()
{
if(tipke.alpha > 5)
{
	if(broj_test_krugova > 0)
{
   odvz_krugova = 0;
	dali_vozi = 0;
	while(brzina < 35)
	{
		brzina += 1; 
		wait(1);
	}
	glediste = 3;
}
else
{
	while(greska_pan.alpha < 80)
	{
		greska_pan.alpha += 5;
		wait(1);
	}
	wait(80);
	while(greska_pan.alpha > 0)
	{
		greska_pan.alpha -= 5;
		wait(1);
	}
}
}
}

function dali_zavrsit()
{
	while(qg_pan.alpha < 80)
	{
		qg_pan.alpha += 5;
	} 
}

function kraj_igre()
{
	if(qg_pan.alpha > 5)
	{
	snd_stopall(4);
	set(tfptg_pan,VISIBLE);
	tfptg_pan.layer = 10;
	while(tfptg_pan.alpha < 100)
	{
		tfptg_pan.alpha += 5;
		wait(1);
	}
	wait(130);
	sys_exit();
	}
}

function klik_fn()
{
	if(tipke.alpha > 5)
{
snd_play(klik,100,0);
}
}

function klik_fn2()
{
	if(izadi_pan.alpha > 5)
{
snd_play(klik,100,0);
}
}

function klik_fn3()
{
if(qg_pan.alpha > 5)
{
snd_play(klik,100,0);
}
}

function nastavi_igrat()
{
	while(qg_pan.alpha > 0)
	{
		qg_pan.alpha -= 5;
		wait(1);
	}	
}